(function() {
  var AwsLogger, Promise, WinstonCloudWatch, debug, winston;

  winston = require("winston");

  Promise = require("bluebird");

  WinstonCloudWatch = require("winston-cloudwatch");

  debug = require("debug")("long-task-queue-reader:logger");

  require("winston-azure-blob-transport");

  module.exports = AwsLogger = (function() {
    function AwsLogger(arg) {
      var access, level, logGroupName, logStreamName, ref, region, secret;
      access = arg.access, secret = arg.secret, region = arg.region, logGroupName = arg.logGroupName, logStreamName = arg.logStreamName, level = (ref = arg.level) != null ? ref : "info";
      this._transport = new WinstonCloudWatch({
        logGroupName: logGroupName,
        logStreamName: logStreamName,
        awsAccessKeyId: access,
        awsSecretKey: secret,
        level: level,
        awsRegion: region || 'us-east-1'
      });
    }

    AwsLogger.prototype.initialize = function() {
      var base;
      return typeof (base = this._transport).initialize === "function" ? base.initialize() : void 0;
    };

    AwsLogger.prototype.transport = function() {
      return this._transport;
    };

    return AwsLogger;

  })();

}).call(this);
