(function() {
  var AbstractMessageExecutor, AwsMessageExecutor,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  AbstractMessageExecutor = require("../abstractMessageExecutor");

  module.exports = AwsMessageExecutor = (function(superClass) {
    extend(AwsMessageExecutor, superClass);

    function AwsMessageExecutor() {
      this._messageId_ = bind(this._messageId_, this);
      this._receiveCount_ = bind(this._receiveCount_, this);
      this._body_ = bind(this._body_, this);
      return AwsMessageExecutor.__super__.constructor.apply(this, arguments);
    }

    AwsMessageExecutor.prototype._body_ = function() {
      return this.message.Body;
    };

    AwsMessageExecutor.prototype._receiveCount_ = function() {
      return parseInt(this.message.Attributes.ApproximateReceiveCount);
    };

    AwsMessageExecutor.prototype._messageId_ = function() {
      return this.message.MessageId;
    };

    return AwsMessageExecutor;

  })(AbstractMessageExecutor);

}).call(this);
