(function() {
  var AzureLogger, Promise, azure, debug, winston;

  winston = require("winston");

  Promise = require("bluebird");

  azure = require("azure-storage");

  debug = require("debug")("long-task-queue-reader:logger");

  require("winston-azure-blob-transport");

  module.exports = AzureLogger = (function() {
    function AzureLogger(arg) {
      var ref;
      this.accountName = arg.accountName, this.accountKey = arg.accountKey, this.container = arg.container, this.name = arg.name, this.level = (ref = arg.level) != null ? ref : "info";
      this._transport = new winston.transports.AzureBlob({
        account: {
          name: this.accountName,
          key: this.accountKey
        },
        containerName: this.container,
        blobName: this.name,
        level: this.level
      });
    }

    AzureLogger.prototype.initialize = function() {
      return this._transport.initialize();
    };

    AzureLogger.prototype.transport = function() {
      return this._transport;
    };

    return AzureLogger;

  })();

}).call(this);
