(function() {
  var AbstractMessageExecutor, AzureMessageExecutor,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  AbstractMessageExecutor = require("../abstractMessageExecutor");

  module.exports = AzureMessageExecutor = (function(superClass) {
    extend(AzureMessageExecutor, superClass);

    function AzureMessageExecutor() {
      this._messageId_ = bind(this._messageId_, this);
      this._receiveCount_ = bind(this._receiveCount_, this);
      this._body_ = bind(this._body_, this);
      return AzureMessageExecutor.__super__.constructor.apply(this, arguments);
    }

    AzureMessageExecutor.prototype._body_ = function() {
      return this.message.messageText;
    };

    AzureMessageExecutor.prototype._receiveCount_ = function() {
      return this.message.dequeueCount;
    };

    AzureMessageExecutor.prototype._messageId_ = function() {
      return this.message.messageId;
    };

    return AzureMessageExecutor;

  })(AbstractMessageExecutor);

}).call(this);
