(function() {
  var KeepAliveMessage, async, convert, retry,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  async = require("async");

  convert = require("convert-units");

  retry = require("bluebird-retry");

  module.exports = KeepAliveMessage = (function() {
    function KeepAliveMessage(message, visibilityTimeout, touch) {
      this.message = message;
      this.visibilityTimeout = visibilityTimeout;
      this.touch = touch;
      this._timeToTouch = bind(this._timeToTouch, this);
      this._callToTouch = bind(this._callToTouch, this);
      this._buildQueue = bind(this._buildQueue, this);
      this.destroy = bind(this.destroy, this);
      this.start = bind(this.start, this);
      this.q = this._buildQueue();
    }

    KeepAliveMessage.prototype.start = function() {
      return this.intervalHandler = setInterval(((function(_this) {
        return function() {
          return _this.q.push(1);
        };
      })(this)), this._timeToTouch());
    };

    KeepAliveMessage.prototype.destroy = function() {
      if (this.intervalHandler == null) {
        throw new Error("should call to start before");
      }
      this.q.kill();
      return clearInterval(this.intervalHandler);
    };

    KeepAliveMessage.prototype._buildQueue = function() {
      return async.queue((function(_this) {
        return function(task, callback) {
          return _this._callToTouch()["finally"](function() {
            return callback();
          });
        };
      })(this));
    };

    KeepAliveMessage.prototype._callToTouch = function() {
      return retry((function(_this) {
        return function() {
          return _this.touch(_this.message);
        };
      })(this));
    };

    KeepAliveMessage.prototype._timeToTouch = function() {
      return convert(this.visibilityTimeout).from("s").to("ms") / 2;
    };

    return KeepAliveMessage;

  })();

}).call(this);
